routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

/*Route::get('/', function () {
    return view('welcome');
});*/

Auth::routes();

/* Admin Auth Route*/
Route::get('admin/', 'LoginController@index');
Route::get('admin/login', 'LoginController@index')->name('admin.login'); 
Route::post('admin/login', 'LoginController@authCheck')->name('admin.login');
Route::get('admin/logout', 'LoginController@logout')->name('admin.logout');


Route::group(['middleware' => 'auth:Admin',  'prefix' => 'admin'], function(){

	Route::get('/dashboard','Admin\DashboardController@index')->name('admin.dashboard');

	Route::resource('employee','Admin\EmployeeController');
	Route::resource('admin-influencer','Admin\InfluencerController');
  Route::get('approve-reject/{id}/{flag}', 'Admin\InfluencerController@approve_reject')->name('admin.approve_reject');
  Route::post('/admin-influencer-list','Admin\InfluencerController@influencer_list')->name('admin.influencer_list');


	Route::resource('admin-shop','Admin\ShopController');
  Route::post('/admin-shop-list','Admin\ShopController@shop_list')->name('admin.shop_list');

  Route::resource('admin-category','Admin\CategoryController');  

  Route::resource('admin-users','Admin\UserController');
  Route::get('/paying-users','Admin\UserController@index')->name('admin.paying_users');
  Route::get('/paid-users','Admin\UserController@paid_users')->name('admin.paid_users');

  Route::get('/assign-shop-into-category','Admin\ShopController@assign_shop_into_category')->name('admin.assign_shop_into_category');

  Route::get('/setting','Admin\DashboardController@setting')->name('admin.setting');
  Route::post('/setting-update','Admin\DashboardController@setting_update')->name('admin.setting_update');

  Route::resource('admin-notification','Admin\NotificationController');

  Route::resource('admin-country','Admin\CountryController');

  Route::get('/import-influencer','Admin\InfluencerController@import_influencer')->name('admin.import_influencer');
  Route::post('/import-influencer','Admin\InfluencerController@import_influencer_store')->name('admin.import_influencer_store');
});


/* User Auth Route*/
Route::get('/', 'LoginController@index');
Route::get('user/login', 'LoginController@index')->name('user.login'); 
Route::post('user/login', 'LoginController@authCheck')->name('user.login');
Route::get('user/logout', 'LoginController@logout')->name('user.logout'); 

Route::get('user/signup', 'SignupController@index')->name('user.signup');
Route::post('user/signup', 'SignupController@signup')->name('user.signup');
Route::post('user/payment-request', 'SignupController@stripe_payment_request')->name('user.stripe_payment_request');

Route::get('user/is-email-already-exists-user', 'SignupController@is_email_already_exists_user')->name('user.is_email_already_exists_user');

Route::group(['middleware' => 'auth:User',  'prefix' => 'user'], function(){

    Route::get('/dashboard','User\DashboardController@index')->name('user.dashboard');
    Route::get('/profile','User\ProfileController@index')->name('user.profile');
    Route::post('/update-email','User\ProfileController@update_email')->name('user.update_email');
    Route::post('/update-password','User\ProfileController@update_password')->name('user.update_password');
    Route::get('/check-old-password','User\ProfileController@check_old_password')->name('user.check_old_password');

    Route::get('/cancel-subscription','User\ProfileController@cancel_subscription')->name('user.cancel_subscription');

    Route::resource('shop','User\ShopController');
    
    Route::resource('trend','User\TrendController');

    Route::resource('influencer','User\InfluencerController');
    Route::get('user/influencer-favourite', 'User\InfluencerController@influencer_favourite')->name('user.influencer_favourite'); 

    Route::resource('live-now','User\LivePromotionController');

    Route::resource('influencer-list','User\InfluencerListController');
    Route::get('assign-influencer/delete', 'User\InfluencerListController@delete')->name('user.influencer_list.delete');
    Route::post('assign-influencer/update', 'User\InfluencerListController@update')->name('user.influencer_list.update');
    Route::get('favourite-influencer-list', 'User\InfluencerListController@favourite_influencer_list')->name('user.favourite_influencer_list'); 

    Route::get('user/assign-influencer', 'User\InfluencerListController@assign_influencer')->name('user.assign_influencer'); 

    Route::resource('shop-list','User\ShopListController');
    Route::get('assign-shop/delete', 'User\ShopListController@delete')->name('user.shop_list.delete');
    Route::post('assign-shop/update', 'User\ShopListController@update')->name('user.shop_list.update');

    Route::get('favourite-shop-list', 'User\ShopListController@favourite_shop_list')->name('user.favourite_shop_list');

    Route::get('user/assign-shop', 'User\ShopListController@assign_shop')->name('user.assign_shop'); 

    Route::resource('media-list','User\MediaListController');
    Route::get('assign-media/delete', 'User\MediaListController@delete')->name('user.media_list.delete');
    Route::post('assign-media/update', 'User\MediaListController@update')->name('user.media_list.update');

    Route::get('user/assign-media', 'User\MediaListController@assign_media')->name('user.assign_media'); 

    Route::resource('notification','User\NotificationController');
     
});

Route::get('/instagram-profile','InstagramAPITestController@index');
Route::get('/profile-stories','InstagramAPITestController@profile_stories');
Route::get('/set-influencer-rank','InstagramAPITestController@set_influencer_rank');
Route::get('/shop-video-concat','InstagramAPITestController@shop_video_concat');
Route::get('/sendinblue-contact-status-update','InstagramAPITestController@sendinblue_contact_status_update');


Route::get('/inst-demo-profile','InstagramAPIDemoController@index');
Route::get('/profile-demo-stories','InstagramAPIDemoController@profile_stories');

Route::get('/clear', function() {

   Artisan::call('cache:clear');
   Artisan::call('config:clear');
   Artisan::call('config:cache');
   Artisan::call('view:clear');
   Artisan::call('clear-compiled');

   return "Cleared!";

});

app/Models/Shop.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;

class Shop extends Model
{
    use SoftDeletes;

    protected $table = 'shop';

    protected $primaryKey = 'shop_id';
	
    protected $fillable = [
        'website', 'language_id', 'influencer_id','website_screenshot', 'admin_id', 'taken_at', 'activity'
    ];
}

app/Http/Controllers/Admin/ShopController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use App\Models\Shop;
use App\Models\Influencer;
use App\Models\Category;
use Hash;
use DB; 
use Session;
use Auth;
use Str;

class ShopController extends Controller
{
    
    public function index()
    { 
        $categories = Category::select("category.*")
            ->latest()
            ->get();
        /*$shops = Shop::select("shop.*","country_name", DB::raw('CONCAT(first_name, " ", last_name) AS name'),DB::raw('GROUP_CONCAT(DISTINCT category.category_name  SEPARATOR "<br />") as categories'), DB::raw('count(DISTINCT shop_category.category_id) as category_cnt'))
            ->leftJoin('influencer','shop.influencer_id', '=' ,'influencer.influencer_id')
            ->leftJoin('countries','countries.country_id', '=' ,'influencer.country_id')
            ->leftJoin('shop_category','shop_category.shop_id', '=' ,'shop.shop_id')
            ->leftJoin('category','category.category_id', '=' ,'shop_category.category_id')
            ->groupBy('shop.shop_id')
            ->latest()
            ->get();*/
        return view('admin.shop.index', compact('shops','categories'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    { 
        $users = Influencer::get();
        $categories = Category::get();
        return view('admin.shop.create', compact('users','categories'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */

    public function store(Request $request)
    { 
        $validator = request()->validate([
            'website' => 'required', // |unique:shop,website,NULL,shop_id,deleted_at,NULL
            'influencer_id' => 'required',
            'category_id' => 'required',
        ]);

        if($request->hasFile('screenshot'))
        { 
            request()->validate([
                'screenshot' => 'image|mimes:jpeg,png,jpg,gif',
            ]);

            $file = $request->file('screenshot');

            $imageName = date("dmYHis").substr(uniqid('', true), -3).'.'.$file->getClientOriginalExtension();  

            $file->move(public_path('site_screenshot'), $imageName);
            $request['website_screenshot'] = $imageName;
        }

        $request['admin_id'] = Auth::guard('Admin')->user()->admin_id;
        $shop = Shop::create($request->all());
        foreach ($request->category_id as $key => $category_id) {
            DB::table('shop_category')->insert(['category_id' => $category_id, 'shop_id' => $shop->shop_id]);
        }
        
        return redirect()->route('admin-shop.index')->with('success','Shop created successfully.');
        
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($shop_id)
    {
        $shop = Shop::find($shop_id);
        $users = Influencer::get();
        $shop_categories = DB::table('shop_category')->where(['shop_id' => $shop_id])->get();
        $shop_category_ids = array();
        foreach ($shop_categories as $key => $shop_category) {
            $shop_category_ids[] = $shop_category->category_id;
        }
        $categories = Category::get();
        return view('admin.shop.edit',compact('shop', 'users', 'categories', 'shop_category_ids'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $shop_id)
    { 
        $shop = Shop::find($shop_id);
        request()->validate([
            'website' => 'required', //|unique:shop,website,'.$shop['shop_id'].',shop_id,deleted_at,NULL
            'influencer_id' => 'required',
            'category_id' => 'required',
        ]);

        if($request->hasFile('screenshot'))
        { 
            request()->validate([
                'screenshot' => 'image|mimes:jpeg,png,jpg,gif',
            ]);

            $file = $request->file('screenshot');

            $imageName = date("dmYHis").substr(uniqid('', true), -3).'.'.$file->getClientOriginalExtension();  

            $file->move(public_path('site_screenshot'), $imageName);
            $request['website_screenshot'] = $imageName;
        }  
        
        $shop->update($request->all());

        DB::table('shop_category')->where(['shop_id' => $shop->shop_id])->delete();
        foreach ($request->category_id as $key => $category_id) {
            DB::table('shop_category')->insert(['category_id' => $category_id, 'shop_id' => $shop->shop_id]);
        }

        return redirect()->route('admin-shop.edit', $shop->shop_id)->with('success','Shop updated successfully.');
    }
    
    public function destroy($id)
    { 
        Shop::find($id)->delete();

        return redirect()->route('admin-shop.index')->with('success','Shop deleted successfully.');
    }

    public function assign_shop_into_category(Request $request){
        if(!empty($request->shop_ids) && !empty($request->category_ids)){
            foreach ($request->category_ids as $key => $category_id) {
                foreach ($request->shop_ids as $key => $shop_id) {
                     $result = DB::table('shop_category')->where([
                        'category_id' => $category_id,
                        'shop_id' => $shop_id
                    ])->first();
                  
                    if(empty($result->shop_category_id)){
                        DB::table('shop_category')->insert([
                            'category_id' => $category_id,
                            'shop_id' => $shop_id
                        ]);
                    }
                }
            }
        }
    }

    public function shop_list(Request $request)
    {
        $columns = array("shop_id","website", "country_name","instagram_id","created_at","categories","shop_id2");
        $columns2 = array("shop.shop_id","website", "country_name","instagram_id","shop.created_at", DB::raw('GROUP_CONCAT(DISTINCT category.category_name  SEPARATOR "<br />") as categories',"shop.shop_id as shop_id2"));

        $totalData = Shop::count();
        $limit = $request->input('length');
        $start = $request->input('start');
        
        $dir   = $request->input('order.0.dir');
            
        $query = Shop::select($columns2);
        $vouchers = $query->leftJoin('influencer','shop.influencer_id', '=' ,'influencer.influencer_id')
            ->leftJoin('countries','countries.country_id', '=' ,'influencer.country_id')
            ->leftJoin('shop_category','shop_category.shop_id', '=' ,'shop.shop_id')
            ->leftJoin('category','category.category_id', '=' ,'shop_category.category_id');

        if (!empty($request->input('search.value'))) {            
            $search = $request->input('search.value');
            $vouchers = $query->where(function ($query2) use ($columns2,$search) {
                foreach ($columns2 as $key => $value) {
                    if ($key == 0) {
                       $query2->where($value,'LIKE',"%{$search}%");
                    } else {
                        if ($key != 5) 
                            $query2->orWhere($value,'LIKE',"%{$search}%");
                    }
                }
                return $query2;
            });
        }

        $vouchers2 = $query->groupBy('shop.shop_id')->get();
        $totalFiltered = $vouchers2->count();

        $vouchers = $query->offset($start);
        $vouchers = $query->limit($limit);
        if(isset($columns2[$request->input('order.0.column')])){
            $order = $columns[$request->input('order.0.column')];
            $vouchers = $query->orderBy($order,$dir);
        }
        $vouchers = $query->latest('shop.created_at', 'desc');
        $vouchers = $query->groupBy('shop.shop_id')->get();

        $data = array();
        if(!empty($vouchers)) {
            foreach ($vouchers as $key => $voucher) {
                $edit_url = route('admin-shop.edit', $voucher->shop_id);
                $delete_url = route('admin-shop.destroy', $voucher->shop_id);
                foreach ($columns as $key2 => $column) {

                    if($column == 'created_at') {
                         $nestedData[$column] = date('M j Y H:i A',strtotime($voucher->$column));
                    } else if($column == 'shop_id') {
                         $nestedData[$column] = '<input type="checkbox" name="shop_ids[]" class="checked-shop-ids" value="'.$voucher->$column.'">';
                    } else if($column == 'website') {
                         $nestedData[$column] = Str::limit($voucher->$column,25);
                    } else if($column == 'categories' && !empty($voucher->categories)) {

                           if(isset($voucher->categories) && !empty($voucher->categories)){
                                $categories2 = explode("<br />", $voucher->categories);
                                         
                                $nestedData[$column] =  ' <span class="category-text">'.$categories2[0].'</span>';
                                    if(count($categories2) > 1)
                                    {   
                                        $nestedData[$column] .= '<span class="category-cnt" data-toggle="tooltip" data-placement="top" data-html="true" title="'.$voucher->categories.'">+'.count($categories2).'</span>';
                                    }
                            }
                    } else if($column == 'shop_id2' && $key2 == 6) {
                        $nestedData[$column] =  "<a href='{$edit_url}'  class='btn btn-primary btn-xs action' target='_blank'><i class='fa fa-pencil'></i></a>

resources/views/admin/shop/index.blade.php
@extends('layout.main')
@section('content')

@section('pagestylesheet')
 <!--alerts CSS -->
    <link href="{{ asset('css/sweetalert.css')}}" rel="stylesheet" type="text/css">
    <link rel="stylesheet" href="{{ asset('css/bootstrap-select.css')}}">
    <style type="text/css">
        #shopTable_filter{
            float: right;
        }
        #shopTable_filter input{
                margin-left: 10px;
        }
        .shopslistings table td:last-child a{
            width: unset;
            padding: 1px 5px;
            border-radius: 3px;
        }
    </style>
@stop

<div class="col-md-9 col-sm-9 col-xs-12 no-padding">
    <div class="middlepart">
        <div class="promotedshops">
            <div class="topbar">
                <h3>Shops</h3>
                 <div class="pull-right">
                    <a href="{{route('admin-shop.create')}}" class="btn btn-blue">Add Shop</a>
                    <a href="Javascript:void(0);" onclick="select_category_list()" class="btn btn-blue">Assign Category</a>
                </div>
            </div>

            <div class="error-contains">
            @if ($message = Session::get('success'))
                <div class="alert alert-success text-success">
                    <i class="fa fa-check"></i> {{ $message }}
                </div>
            @endif
            </div>
           
            <div class="shopslistings">
                <div class="shopslistingsinner">
                    <table id="shopTable" class="table display nowrap" width="100%">
                    <thead>
                        <tr>
                            <th><input type="checkbox" id="checked-all"></th>
                            <th>Website</th>
                            <th class="text-center">Country</th>
                            <th class="text-center">Influencer</th>
                            <th class="text-center">Created At</th>
                            <th class="text-center">Categories</th>
                            <th class="text-center no-sort">Action</th>
                        </tr>
                    </thead>
                    <tbody>
                        <?php /*
                        @if(!empty($shops))
                            @foreach($shops as $shop)
                            <tr>
                                <td><input type="checkbox" name="shop_ids[]" class="checked-shop-ids" value="{{$shop->shop_id}}" /></td>
                                <td class="text-center"><a href="{{$shop->website}}" target="_blank">{{ Str::limit($shop->website, 25) }}</a></td>
                                <td class="text-center">{{$shop->country_name}}</td>
                                <td class="text-center">{{$shop->name}}</td>
                                <td class="text-center">{{date("M d Y h:i A", strtotime($shop->created_at))}}</td>
                                
                                <td>@if(!empty($shop->categories))
                                      @php
                                      $categories2 = explode("<br />", $shop->categories);
                                      @endphp

                                      <span class="category-text">{{ $categories2[0] }}</span>
                                      @if(count($categories2) > 1)
                                          <span class="category-cnt" data-toggle="tooltip" data-placement="top" data-html="true" title="{{$shop->categories}}">+{{ $shop->category_cnt }}</span>
                                      @endif
                                    @endif
                                </td>
                                <td class="text-center">
                                    <a href="{{route('admin-shop.edit', $shop->shop_id)}}"  class="btn btn-primary btn-xs action" target="_blank"><i class="fa fa-pencil"></i></a>
                                    
                                     <form action="{{route('admin-shop.destroy', $shop->shop_id)}}" method='POST' id='laravel_datatable-{{$shop->shop_id}}' style="    display: -webkit-inline-box;">
                                        <input name='_method' type='hidden' value='DELETE'>
                                        {{csrf_field()}}
                                        <button type='button' title='DELETE' class='btn btn-danger btn-xs action' onclick='delete_shop("{{$shop->shop_id}}");'>
                                            <i class='fa fa-trash-o text-danger'></i>
                                        </button>
                                    </form>
                                </td>
                                <td style="display: none;"></td>
                            </tr>
                            @endforeach
                        @endif */ ?>
                    </tbody>
                    </table>
                </div>
                
            </div>
        </div>
    </div>
</div>

<div id="assign-shop-modal" class="modal fade" role="dialog">
  <div class="modal-dialog">
    <!-- Modal content-->
    <div class="modal-content">     
          <div class="modal-header">
            <button type="button" class="close" data-dismiss="modal">&times;</button>
            <h4 class="modal-title">Assign shop into category</h4>
          </div>
          <div class="modal-body">
            
            <input type="hidden" id="assign_influencer_id">
            <div class="form-group row">
                <label class="control-label col-sm-2">Category Name:</label>
                <div class="col-sm-10">
                    <select class="form-control selectpicker" id="assign_category_ids" multiple=""> 
                        <option value="" disabled="">Select Category List</option>
                        @foreach($categories as $category)
                         <option value="{{$category->category_id}}">{{$category->category_name}}</option>
                        @endforeach
                    </select>
                    <div class="assign-shop-msg text-success"></div>
                </div>
            </div>
          </div>
          <div class="modal-footer">
            <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
            <button type="button" class="btn btn-blue assign-shop-btn">Submit</button>
          </div>
    </div>
  </div>
</div>                    
@endsection

@section('pagescript')
    <script src="{{ asset('js/jquery.dataTables.min.js')}}"></script>
     <!-- Sweet-Alert  -->
    <script src="{{ asset('js/sweetalert.min.js')}}"></script>
    <script src="{{ asset('js/bootstrap-select.js')}}"></script>
    <script>
        $(document).ready(function() {

            $('#shopTable').DataTable({
                "scrollX": true,
                "processing": true,
                "serverSide": true,
                "searching": true,
                "ajax": {
                             "url"      : "{{route('admin.shop_list')}}",
                             "dataType" : "JSON",
                             "type"     : "POST",
                             "data"     : { _token: $('meta[name="csrf-token"]').attr('content') }
                        },
                "columns": [
                      { "data": "shop_id", "orderable": false, "class" : "text-center" },
                      { "data": "website", "class" : "text-left"},
                      { "data": "country_name", "class" : "text-center"},
                      { "data": "instagram_id", "class" : "text-center"},
                      { "data": "created_at", "class" : "text-center"},
                      { "data": "categories", "orderable": false, "class" : "text-center"},
                      { "data": "shop_id2", "orderable": false, "class" : "text-center"},
                ],
                "aaSorting": [],
                "language": {
                    "paginate": {
                        "previous": "<i class='fa fa-angle-left'><i/>",
                        "next": "<i class='fa fa-angle-right'><i/>",

                    }
                },
            });


            $('.selectpicker').selectpicker({
                tickIcon: 'fa fa-check'
            });

            /*$('#shoptable').DataTable( {
                searching: true,
                ordering:  true,
                "language": {
                    "paginate": {
                        "previous": "<i class='fa fa-angle-left'><i/>",
                        "next": "<i class='fa fa-angle-right'><i/>",

                    }
                },
            } );*/
        } );
        $(document).on("click", "#checked-all", function(){
            if(this.checked)
                $("input[type=checkbox]").prop('checked', true);
            else
                $("input[type=checkbox]").prop('checked', false);
        });
        $(document).on('click', '.assign-shop-btn', function(e) { 

            if($("#assign_category_ids").val() != null){
                var shop_ids = $('input.checked-shop-ids:checked').map( function () { 
                    return $(this).val();
                }).get();
               // var shop_ids = $("#assign_shop_ids").val();
                var category_ids = $("#assign_category_ids").val();
                $.ajax({
                    url : "{{route('admin.assign_shop_into_category')}}",
                    data : { shop_ids:shop_ids, category_ids:category_ids},
                }).done(function (data) { 
                    $('.assign-shop-msg').html('Shop assigned successfully.');
                    $('input.checked-shop-id').prop('checked', false);
                    location.reload();
                });
            } else {
                alert("Please select at least one category.");
            }
        });

        function select_category_list(){
            if($('input.checked-shop-ids:checked').length > 0){
                $("#assign-shop-modal").modal("show");
            } else {
                alert("Please select at least one shop.");
            }
        }
        function delete_shop(shop_id){

            swal({   
                title: "Are you sure?",   
                text: "You will not be able to recover this data!",   
                type: "warning",   
                showCancelButton: true,   
                confirmButtonColor: "#8BC34A",   
                confirmButtonText: "Yes, delete it!",   
                closeOnConfirm: false,
                showLoaderOnConfirm: true,
                /*iconColor: '#000',*/
            }, function(){   
                swal("Deleted!", "Your data has been deleted.", "success"); 
                $("#laravel_datatable-"+shop_id).submit();
                return true;
            });

            return false;
        }
    </script>
@stop